//----------------------------------------------------------------------------
//  Description :
//      Yacc input file; FirmStyle & Metrics common analysis parser
//----------------------------------------------------------------------------
//  Changes:
//  $Log__$
//----------------------------------------------------------------------------

#include <stdio.h>
#include <string.h>

#ifdef DEBUG
   #ifdef BRANKO
      #include "debug.h"
   #endif
#endif

/* obrada deklaracija i tabela simbola */
#include "fsbool.h"
#include "fserror.h"
#include "fssymtab.h"

/* leksicki analizator */
#include "fsanzopt.h"
#include "fslex.h"

inline void yyerror( char *str )
{
   if ( strcmp( str, "syntax error" ) != 0 ) FSAnzFatalError( E_PARSER_STACK_OVERFLOW );
}

// specific for pcyacc
#define yychar pcyytoken
#define YYEMPTY -1
#define YYACCEPT return(0)

typedef union  {
	FSSymbol *ptrSym;
	FSType *ptrType;
	FSSymbolList *ptrSymList;
	FSBaseTypeSpecifiers spec;
	FSTypeId typId;
    char *ptrChar;
	char ascii;
} YYSTYPE;
#define _SPEC_MOD 257
#define _SPEC_QUAL 258
#define _SEGMENT 259
#define _HW_SPEC_QUAL 260
#define _HI_TECH_SPEC_QUAL 261
#define _SPEC_STRG_CL 262
#define _SBIT 263
#define _BIT 264
#define _SFR 265
#define _SFR16 266
#define _SFRP 267
#define _BASED 268
#define _IAR_INT 269
#define _IAR_USING 270
#define _THREAD 271
#define _ASM 272
#define _HI_TECH_ASM 273
#define _EXCEPT 274
#define _FINALLY 275
#define _TRY 276
#define _PRIORITY 277
#define _TASK 278
#define _USING 279
#define _AT 280
#define _COSMIC_6805_AT 281
#define _C51_NOPAR 282
#define _C51_166_INT 283
#define _C166_REGMASK 284
#define _IAR_UNARY 285
#define _IAR_ARGS 286
#define _IAR_CON 287
#define _SEGNAME 288
#define _SELF 289
#define _EMIT 290
#define NEWLINE 291
#define SHARP 292
#define SHARPSHARP 293
#define _ASM_START 294
#define _ASM_END 295
#define STRING 296
#define ICON 297
#define FCON 298
#define TYPE 299
#define CONST_VOLAT 300
#define STRUCT 301
#define ENUM 302
#define TTYPE 303
#define CLASS 304
#define NAME 305
#define ELSE 306
#define RETURN 307
#define GOTO 308
#define IF 309
#define SWITCH 310
#define CASE 311
#define DEFAULT 312
#define BREAK 313
#define CONTINUE 314
#define WHILE 315
#define DO 316
#define FOR 317
#define LC 318
#define RC 319
#define SEMI 320
#define ELLIPSIS 321
#define COMMA 322
#define EQUAL 323
#define ASSIGNOP 324
#define QUEST 325
#define COLON 326
#define OROR 327
#define ANDAND 328
#define OR 329
#define XOR 330
#define AND 331
#define EQUOP 332
#define RELOP 333
#define SHIFTOP 334
#define PLUS 335
#define MINUS 336
#define STAR 337
#define DIVOP 338
#define SIZEOF 339
#define UNOP 340
#define INCOP 341
#define _BASE_OPERATOR 342
#define LB 343
#define RB 344
#define LP 345
#define RP 346
#define STRUCTOP 347
YYSTYPE yylval, yyval;
#define YYERRCODE 256
const int yyexca[] = {
  -1, 1,
  0, -1,
  -2, 0,
  -1, 2,
  0, 1,
  301, 49,
  302, 47,
  303, 51,
  -2, 30,
  -1, 6,
  301, 49,
  302, 47,
  303, 51,
  -2, 29,
  -1, 31,
  320, 21,
  322, 21,
  -2, 168,
  -1, 61,
  302, 47,
  303, 51,
  318, 9,
  -2, 49,
  -1, 73,
  302, 47,
  303, 51,
  -2, 49,
  -1, 77,
  302, 47,
  303, 51,
  -2, 49,
  -1, 86,
  318, 58,
  -2, 57,
  -1, 89,
  318, 150,
  -2, 152,
  -1, 99,
  302, 47,
  303, 51,
  -2, 49,
  -1, 122,
  302, 47,
  303, 51,
  320, 181,
  -2, 49,
  -1, 146,
  301, 49,
  302, 47,
  303, 51,
  -2, 125,
  -1, 197,
  302, 47,
  303, 51,
  346, 125,
  -2, 49,
  -1, 200,
  302, 47,
  303, 51,
  -2, 49,
  -1, 230,
  302, 47,
  303, 51,
  -2, 49,
  -1, 240,
  301, 49,
  302, 47,
  303, 51,
  -2, 82,
  -1, 254,
  301, 49,
  302, 47,
  303, 51,
  319, 147,
  -2, 30,
  -1, 291,
  301, 49,
  302, 47,
  303, 51,
  -2, 204,
  -1, 300,
  302, 47,
  303, 51,
  -2, 49,
  -1, 336,
  302, 47,
  303, 51,
  320, 191,
  -2, 49,
  -1, 390,
  326, 242,
  -2, 283,
  -1, 419,
  346, 241,
  -2, 239,
  -1, 420,
  346, 241,
  -2, 239,
  -1, 458,
  320, 241,
  -2, 239,
  -1, 473,
  346, 241,
  -2, 239,
  0,
};

#define YYNPROD 307
#define YYLAST 1546

const int yyact[] = {
      91,      66,     368,     445,      70,     207,      36,      90,
     394,     108,     442,      43,     151,     375,     359,     213,
     167,      92,      58,     173,      31,     480,     173,      35,
      40,     193,      34,     333,     400,     173,      33,      73,
     137,      40,      44,     479,      68,     193,      71,     457,
     167,     455,      81,     460,     173,      45,     454,     432,
      44,      67,      72,      82,      71,     331,     173,     350,
      37,     137,      69,      45,      36,     127,     239,     117,
     240,      37,     461,      78,     328,      77,     281,     125,
     244,      38,     119,     152,     152,     152,     279,     190,
     189,     191,      40,     194,     165,     192,     163,      62,
     154,     156,     330,     190,     189,     191,     230,     194,
     248,     192,     358,     193,     195,     346,      23,      21,
      24,      25,     229,      13,      14,      15,      17,      16,
     325,      26,      37,      44,     226,     332,     129,     118,
     239,     230,     240,     206,     214,      27,      45,      43,
      37,     105,     104,     101,     106,     103,     239,     140,
     240,      28,     230,     158,      83,     102,     100,      11,
      22,     129,     139,      40,     233,     107,      63,     232,
      64,     473,     152,     191,     249,     194,     167,     192,
     280,     167,     129,      40,     428,     128,     242,     427,
     361,     136,     236,     421,     230,     238,      63,     113,
      64,     237,     420,      37,     110,     114,     227,     109,
     111,     112,      40,      38,     299,      99,     300,     345,
     273,     258,     259,      37,     129,     419,     416,     284,
     405,     287,     232,      38,     225,     228,     129,     407,
     329,     285,     286,     166,     278,     398,      75,      76,
     348,      78,      37,      77,     246,     200,     243,      44,
     282,     199,      38,     118,     283,     293,     299,      37,
     300,      63,      45,      64,     138,     239,     173,     240,
      68,     235,      44,      23,      21,      24,      25,     306,
      13,      14,      15,      17,      16,      45,      26,     129,
      78,      74,      77,     135,     324,     236,     302,     217,
     238,     238,      27,     198,     237,     237,      78,      40,
      77,      84,     320,     321,      73,      78,      44,      77,
      41,     289,      71,     172,      11,      22,      52,     319,
     115,      45,      40,     178,     361,     181,     182,     214,
     177,     441,     117,     276,     418,     126,     307,      37,
     126,     415,     402,     341,     126,     282,     282,      38,
     152,     283,     283,     183,     187,     188,     181,     182,
     360,     315,      37,     353,     351,     174,      40,     364,
     239,     296,     240,     187,     188,     181,     182,     370,
     173,     437,     396,     173,     481,      43,     236,     355,
     278,     363,     176,     175,     174,     362,     208,     126,
     395,     176,     175,     174,     365,     310,      37,      51,
     311,     429,     342,      59,     472,      68,      38,     468,
     458,     406,     401,     349,      59,     412,     409,     403,
     173,     410,     180,     179,     183,     187,     188,     181,
     182,     417,     236,     302,     413,     363,     363,     425,
     426,     362,     362,     186,     185,     184,     180,     179,
     183,     187,     188,     181,     182,     360,     399,     438,
     117,       7,     292,     430,      59,     434,     123,     313,
      42,     440,     433,     431,     424,     423,     446,     370,
     404,     447,     436,     236,     448,     294,     363,     444,
     396,     152,     362,     117,     247,     171,     449,     450,
     370,      57,     453,      60,     456,     451,     395,     185,
     184,     180,     179,     183,     187,     188,     181,     182,
     370,     170,     463,     179,     183,     187,     188,     181,
     182,     370,     467,     471,     469,     465,     369,     326,
     176,     175,     174,     370,     446,     477,     312,     478,
     459,     314,     252,     370,     476,     483,     388,     389,
     387,     386,     385,     275,     470,     161,     251,      55,
     414,      54,     224,     105,     104,     101,     106,     103,
      55,      56,      54,      59,     221,     274,      83,     102,
     100,     253,      55,      40,      54,      89,      86,     390,
      50,     372,     374,     379,     376,     377,     378,     383,
     384,     380,     382,     381,      42,     367,     373,      47,
      49,     338,     295,     222,     216,     219,      83,     253,
     369,     113,     167,     218,     255,      95,     110,     114,
     215,     109,     111,     112,     212,     147,       4,      99,
     388,     389,     387,     386,     385,     184,     180,     179,
     183,     187,     188,     181,     182,     105,     104,     101,
     106,     103,     245,      39,     145,     261,      96,     260,
      83,     102,     100,       6,      94,      53,      93,     408,
     257,     390,     256,     372,     374,     379,     376,     377,
     378,     383,     384,     380,     382,     381,     443,     146,
     373,      23,      21,      24,      25,      10,      13,      14,
      15,      17,      16,     113,      26,     466,      32,     422,
     110,     114,     366,     109,     111,     112,     482,     475,
      27,      99,     391,      44,      23,      21,      24,      25,
      10,      13,      14,      15,      17,      16,      45,      26,
     464,     122,      11,      22,     474,     144,     304,       9,
     462,     196,     143,      27,     209,      44,      23,      21,
      24,      25,      10,      13,      14,      15,      17,      16,
      45,      26,     131,     133,     132,      11,      22,     130,
     134,     116,       9,      40,     439,      27,     235,      44,
      23,      21,      24,      25,     371,      13,      14,      15,
      17,      16,      45,      26,     334,     290,     452,      11,
      22,     241,     393,     197,       9,      40,      12,      27,
     392,     335,     339,      37,      44,      23,     291,      24,
      25,     347,     220,      38,     223,     211,     210,      45,
      26,      11,      22,     105,     104,     101,     106,     103,
     160,      65,     121,     340,      27,      37,      83,     102,
     100,     357,      42,     356,      80,      38,     317,     107,
     316,      20,      19,      18,     397,     120,     288,      22,
      61,      30,      29,     305,     153,       3,       2,      37,
     105,     104,     101,     106,     103,     239,       1,     240,
      79,     113,     234,      83,     102,     100,     110,     114,
     250,     109,     111,     112,     107,     254,     164,      99,
     105,     104,     101,     106,     103,     352,      85,      87,
      88,      46,      48,      83,     102,     100,     142,     297,
     197,       0,     322,     298,     107,     318,     113,       0,
       0,       0,       0,     110,     114,       0,     109,     111,
     112,     162,       0,     126,      99,     105,     104,     101,
     106,     103,       0,       0,       0,       0,     113,       0,
      83,     102,     100,     110,     114,       0,     109,     111,
     112,     107,     337,     126,      99,       0,     105,     104,
     101,     106,     103,       0,       0,       0,     157,       0,
       0,      83,     102,     100,       0,       0,       0,       0,
       0,       0,     107,     113,       0,       0,       0,     336,
     110,     114,       0,     109,     111,     112,     155,       0,
       0,      99,     277,     105,     104,     101,     106,     103,
       0,       0,       0,     309,     113,       0,      83,     102,
     100,     110,     114,       0,     109,     111,     112,     107,
       0,     126,      99,     105,     104,     101,     106,     103,
       0,       0,       0,     150,     153,       0,      83,     102,
     100,       0,       0,       0,       0,       0,       0,     107,
       0,     113,       0,       0,       0,       0,     110,     114,
       8,     109,     111,     112,     153,       0,       0,      99,
     105,     104,     101,     106,     103,       0,       0,     344,
       0,     113,       0,      83,     102,     100,     110,     114,
       0,     109,     111,     112,     107,       0,       0,      99,
       0,       0,       0,       0,       0,       0,       0,       0,
     141,     153,      23,      21,      24,      25,       0,      13,
      14,      15,      17,      16,       0,      26,     113,       0,
       0,       0,       0,     110,     114,     124,     109,     111,
     112,      27,       0,       0,      99,       0,       0,       0,
     301,     303,     149,       0,       0,       0,     149,       0,
       0,       0,     435,      11,      22,       0,       0,       0,
       0,      40,     105,     104,     101,     106,     103,       0,
       0,       0,       0,       0,     149,      83,     102,     100,
       0,     148,       0,       0,       0,       0,     107,     105,
     104,     101,     106,     103,       0,     303,     301,       0,
       0,       0,      83,     102,     100,       0,       0,       0,
       0,       0,     129,     107,       0,       0,       0,       0,
     113,       0,       0,       0,       0,     110,     114,       0,
     109,     111,     112,     231,       0,     126,      99,       0,
       0,       0,       0,       0,       0,     113,       0,       0,
       0,       0,     110,     114,     354,     109,     111,     112,
       0,       0,       0,      99,     105,     104,     101,     106,
     103,       0,       0,       0,       0,       0,       0,      83,
     102,     100,       0,       0,       0,       0,       0,       0,
     107,     105,     104,     101,     106,     103,     231,       0,
       0,     149,       0,       0,      83,     102,     100,     411,
       0,       0,       0,       0,       0,     107,       0,       0,
       0,       0,     113,       0,       0,       0,       0,     110,
     114,       0,     109,     111,     112,       0,       0,     149,
      99,       0,       0,       0,       0,       0,       0,     113,
       0,     149,       0,       0,     110,     114,       0,     109,
     111,     112,       0,       0,       0,      99,     105,     104,
     101,     106,     103,      97,       0,       0,       0,       0,
       0,      83,     102,     100,     343,       0,      23,      21,
      24,      25,     107,      13,      14,      15,      17,      16,
       0,      26,       0,       0,       0,       0,       0,     153,
       0,       0,       0,       0,       0,      27,       0,       0,
       0,       0,       0,       0,     113,     149,       0,       0,
       0,     110,     114,       0,     109,     111,     112,      11,
      22,       0,      99,     105,     104,     101,     106,     103,
      98,       0,       0,       0,       0,       0,      83,     102,
     100,     169,       0,       0,       0,     148,     159,     107,
      23,      21,      24,      25,       0,      13,      14,      15,
      17,      16,       0,      26,       0,       0,       0,       0,
     105,     104,     101,     106,     103,       0,     129,      27,
       0,     113,       0,      83,     102,     100,     110,     114,
       0,     109,     111,     112,     107,       0,       0,      99,
       0,      11,      22,       0,       0,       0,       0,       0,
     308,       0,      23,      21,      24,       0,       0,      13,
      14,      15,      17,      16,       0,      26,     113,     148,
       0,       0,       0,     110,     114,     168,     109,     111,
     112,      27,       0,       0,      99,       0,      23,      21,
      24,      25,       0,      13,      14,      15,      17,      16,
     129,      26,       0,      11,      22,       0,       0,     201,
     202,     203,     204,     205,       0,      27,       0,     262,
     263,     264,     265,     266,     267,     268,     269,     270,
     271,     148,       0,       0,       0,       0,       0,      11,
      22,      44,      23,      21,      24,      25,      10,      13,
      14,      15,      17,      16,      45,      26,       0,       0,
       0,       0,     129,       0,       0,     148,       0,       0,
       0,      27,      23,      21,      24,      25,      10,      13,
      14,      15,      17,      16,       0,      26,       0,       0,
       0,       5,       0,      11,      22,       0,       0,       0,
       9,      27,       0,       0,       0,       0,     272,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,     323,       0,      11,      22,       0,       0,       0,
       9,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,     327,
};

const int yypact[] = {
   -4096,   -4096,    1168,   -4096,    -119,     -65,    1144,   -4096,
   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,
   -4096,   -4096,     233,     235,     217,   -4096,   -4096,   -4096,
   -4096,   -4096,      16,     192,   -4096,     185,     123,    -169,
   -4096,    -272,      21,     -69,     -66,     459,   -4096,   -4096,
   -4096,     246,   -4096,   -4096,   -4096,     -72,   -4096,     213,
   -4096,     212,   -4096,    1011,     -55,   -4096,   -4096,   -4096,
   -4096,   -4096,    -142,   -4096,   -4096,     351,   -4096,     749,
     -91,     397,     -73,    -193,     -87,    -314,   -4096,   -4096,
    -110,     728,     667,     630,     606,    1022,     569,     459,
   -4096,   -4096,    -135,   -4096,     974,     139,   -4096,     119,
   -4096,   -4096,     -61,   -4096,      23,   -4096,     -31,   -4096,
     -37,      66,    -262,    -156,   -4096,   -4096,   -4096,   -4096,
   -4096,     -78,    -120,   -4096,     250,    -124,    1011,    1011,
    1011,    1011,    1011,    1011,   -4096,   -4096,   -4096,    -169,
      32,   -4096,     404,   -4096,   -4096,       7,   -4096,   -4096,
   -4096,     263,   -4096,     244,     211,     242,     201,   -4096,
   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,    -140,    -150,
   -4096,   -4096,     -15,   -4096,   -4096,   -4096,   -4096,   -4096,
      14,     913,   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,
    -184,     292,   -4096,     -36,   -4096,   -4096,     116,   -4096,
    -250,    -190,     238,   -4096,     278,   -4096,   -4096,    1011,
    1011,   -4096,   -4096,    1011,    1011,    1011,    1011,    1011,
    1011,    1011,    1011,    1011,    1011,    1011,   -4096,    1011,
     204,   -4096,     544,    -268,    -186,     430,    1011,     246,
    -156,    -262,    -262,    -262,    -262,    -262,     -63,   -4096,
   -4096,   -4096,      90,     109,   -4096,    -193,     -73,   -4096,
   -4096,   -4096,     241,   -4096,   -4096,   -4096,   -4096,       6,
   -4096,   -4096,   -4096,     210,   -4096,   -4096,    1100,   -4096,
   -4096,     -73,    -113,   -4096,   -4096,    -281,    -223,     507,
    1072,      38,   -4096,   -4096,   -4096,     292,   -4096,   -4096,
   -4096,   -4096,     159,   -4096,   -4096,      -2,     351,     -56,
    1011,    1011,      23,      23,    1011,    1011,     -19,     126,
   -4096,   -4096,      -4,      46,     234,     117,     -44,     -44,
    -188,     -84,   -4096,   -4096,    -234,   -4096,     149,   -4096,
    1011,   -4096,    -209,    -106,    -278,    -138,    -256,    -293,
    -229,   -4096,   -4096,     351,   -4096,    -142,   -4096,   -4096,
     240,   -4096,   -4096,     483,     956,    -113,    -289,    -155,
     292,   -4096,     -40,   -4096,   -4096,    -201,   -4096,     913,
   -4096,   -4096,     208,     852,      24,   -4096,    -158,    1011,
      23,      30,   -4096,      66,   -4096,   -4096,    1011,    -262,
   -4096,   -4096,   -4096,   -4096,   -4096,   -4096,     214,   -4096,
     378,   -4096,   -4096,     292,   -4096,     -43,   -4096,   -4096,
    -228,   -4096,   -4096,     292,   -4096,   -4096,   -4096,   -4096,
   -4096,   -4096,   -4096,   -4096,      50,     104,   -4096,   -4096,
    -126,    1011,    -272,      21,    -137,   -4096,   -4096,   -4096,
   -4096,   -4096,      54,      32,     831,   -4096,     191,     -21,
    -147,    1011,     -26,    -148,    -167,    -174,   -4096,     101,
     100,      32,      32,    -178,   -4096,    -181,   -4096,   -4096,
      41,      99,   -4096,    -193,    -276,     292,   -4096,   -4096,
   -4096,   -4096,   -4096,     -34,   -4096,     770,   -4096,   -4096,
    1011,   -4096,   -4096,   -4096,      17,      87,   -4096,   -4096,
    1011,     -29,   -4096,   -4096,   -4096,    1011,     288,   -4096,
   -4096,   -4096,   -4096,    1011,     246,   -4096,    -142,   -4096,
     446,   -4096,   -4096,   -4096,       0,   -4096,   -4096,     288,
    -300,   -4096,    -305,    1011,    -307,      48,      14,     165,
    -303,    -280,   -4096,   -4096,   -4096,   -4096,   -4096,     288,
      14,   -4096,   -4096,   -4096,      32,      47,      32,     186,
     288,      44,    -192,   -4096,   -4096,   -4096,   -4096,   -4096,
   -4096,   -4096,     288,    1011,    -311,   -4096,    -325,      20,
   -4096,   -4096,     288,   -4096,
};

const int yypgo[] = {
       0,     607,     587,     558,     409,     944,     622,       8,
       1,      15,     579,      23,     482,     580,     557,     778,
     556,     806,     658,     802,     801,     800,     799,      14,
     798,     789,     784,      30,     776,       4,     710,     774,
     766,     765,     762,     761,     760,     757,       5,       9,
      18,      12,    1264,     755,     754,     753,       7,      61,
     414,      26,     589,     752,     750,     747,     745,     738,
     737,     726,     725,     718,     713,     712,     706,       0,
     705,     701,     700,       2,     692,      13,     684,     656,
      10,     652,     648,       3,     631,     630,     623,     621,
     606,     594,      17,     592,     591,     590,     588,     583,
     549,     582,     581,    1203,     299,
};

const int yyr1[] = {
       0,      31,      32,      32,      33,      33,      33,      35,
      33,      37,      33,      33,      34,      34,       6,       6,
       6,       6,       6,       6,       6,       6,       6,      40,
      40,      40,      29,      29,      29,       3,       3,       2,
       2,       2,       1,       1,       1,       4,       4,       4,
       5,       5,       5,       5,       5,       5,       5,      43,
       5,      44,       5,      45,       5,       5,      20,      20,
      20,      20,      24,      24,      26,      26,      12,      12,
      12,       8,       8,       8,       8,       8,       8,       8,
       8,       8,       8,       8,       8,      48,      48,      11,
      11,      10,      49,      49,      49,      47,      47,      27,
      27,      28,      28,      28,      28,      30,      30,      30,
      30,      30,      30,      30,      30,      30,       9,       9,
       9,       9,       9,       9,       9,       9,       9,       9,
       9,       9,       9,       9,       9,      17,      17,      18,
      18,      13,      13,      13,      14,      14,      14,      15,
      15,      15,      15,      15,      15,      15,      15,      15,
      15,      15,      15,      15,      15,      15,      15,      15,
      15,      15,      15,      51,      19,      19,      22,      22,
      21,      25,      25,      52,      52,      54,      52,      52,
      53,      53,      23,      23,      23,      23,      36,      36,
      56,      56,      56,      56,      56,      56,      56,      56,
      56,      50,      50,      55,      55,      58,      55,      57,
      57,      16,      16,      59,      59,      60,      60,      62,
      60,      61,      61,       7,       7,       7,       7,      41,
      41,      64,      64,      38,      65,      66,      66,      67,
      67,      68,      67,      67,      67,      67,      67,      70,
      67,      71,      67,      67,      67,      67,      73,      67,
      74,      67,      76,      77,      67,      78,      79,      67,
      67,      67,      67,      67,      67,      67,      67,      80,
      72,      72,      69,      75,      75,      46,      81,      63,
      63,      83,      84,      82,      82,      82,      82,      85,
      87,      86,      86,      88,      90,      89,      89,      91,
      91,      91,      91,      91,      91,      91,      91,      91,
      91,      91,      42,      42,      42,      42,      42,      42,
      42,      42,      42,      42,      42,      42,      42,      42,
      42,      42,      42,      42,      42,      42,      42,      42,
      42,      42,      42,      42,      42,      42,      42,      39,
      39,      92,      92,
};

const int yyr2[] = {
       0,       1,       2,       0,       2,       3,       3,       0,
       3,       0,       5,       5,       1,       3,       1,       3,
       3,       3,       3,       3,       3,       1,       2,       1,
       2,       2,       1,       4,       4,       1,       0,       1,
       2,       2,       1,       2,       2,       1,       1,       1,
       1,       1,       1,       1,       1,       1,       1,       0,
       2,       0,       2,       0,       2,       1,       5,       5,
       4,       2,       1,       0,       1,       3,       1,       3,
       3,       1,       3,       3,       4,       4,       3,       3,
       4,       4,       2,       3,       3,       1,       2,       1,
       3,       1,       1,       2,       2,       1,       3,       1,
       2,       1,       1,       2,       2,       1,       1,       1,
       1,       1,       4,       5,       8,       2,       2,       3,
       3,       4,       4,       3,       3,       3,       3,       3,
       3,       4,       4,       4,       4,       1,       3,       1,
       3,       2,       1,       1,       2,       1,       2,       3,
       3,       2,       1,       3,       3,       4,       4,       2,
       2,       3,       3,       3,       3,       4,       4,       2,
       2,       3,       3,       0,       6,       2,       1,       0,
       1,       2,       0,       3,       3,       0,       3,       2,
       1,       3,       1,       3,       3,       2,       2,       1,
       0,       2,       3,       3,       3,       3,       3,       3,
       5,       1,       1,       2,       3,       0,       3,       1,
       3,       1,       1,       2,       0,       2,       3,       0,
       3,       1,       3,       1,       1,       3,       3,       1,
       3,       1,       3,       4,       1,       2,       0,       1,
       2,       0,       2,       2,       3,       1,       3,       0,
       4,       0,       6,       3,       2,       5,       0,       8,
       0,       6,       0,       0,      11,       0,       0,       9,
       2,       2,       2,       2,       5,       1,       5,       0,
       2,       0,       1,       1,       0,       1,       0,       4,
       1,       0,       0,       7,       3,       3,       1,       1,
       0,       4,       1,       1,       0,       4,       1,       3,
       3,       3,       3,       3,       3,       3,       3,       3,
       3,       1,       3,       1,       1,       1,       1,       1,
       4,       3,       4,       1,       1,       4,       4,       4,
       4,       4,       3,       2,       2,       2,       2,       2,
       2,       4,       3,       3,       2,       4,       3,       1,
       2,       1,       3,
};

const int yychk[] = {
   -4096,     -31,     -32,     -33,      -3,     273,      -2,      -4,
      -5,     304,     262,     299,     -30,     263,     264,     265,
     267,     266,     -43,     -44,     -45,     259,     300,     258,
     260,     261,     269,     281,     256,     -34,     -35,      -9,
      -6,     -27,     -49,     -11,      -8,     337,     345,     -10,
     305,     345,      -4,     -29,     257,     268,     -20,     302,
     -19,     301,     303,     343,     270,     -50,     305,     303,
     320,     256,     -40,     322,     320,     -36,     256,     343,
     345,     -56,      -8,      -9,      -8,     -11,     -29,     261,
      -9,     345,     323,     280,     281,     345,     343,     -28,
     -30,     -29,     -39,     296,     345,     -24,     305,     -22,
     -21,     305,     -46,     -63,     -82,     -85,     -86,     -88,
     -89,     -91,     -42,     345,     298,     287,     297,     289,
     286,     285,     288,     305,     -39,     339,     336,     340,
     341,     331,     337,     343,      -6,     -29,     261,      -9,
     -37,     -55,      -2,     -48,     256,     -46,     344,     -47,
     256,     346,     282,     277,     279,     278,     283,     346,
     256,     346,     346,     256,     -47,     256,     -17,     -18,
     -10,     -13,      -1,     -14,     321,      -5,     256,     -41,
     -63,     318,     -41,     256,     -41,     256,     -47,     256,
     -18,     -48,     256,     -46,     -30,     -29,     346,     296,
     -42,     299,     318,     318,     344,     322,     325,     324,
     323,     327,     328,     333,     332,     337,     338,     334,
     331,     330,     329,     335,     336,     342,     341,     343,
     347,     287,     345,     -63,     -14,      -1,     345,     345,
     345,     -42,     -42,     -42,     -42,     -42,     -46,     -38,
     318,     256,     -57,     -58,     -16,      -9,      -8,     260,
     -48,     256,     284,     297,     -50,     297,     297,     -50,
     297,     -47,     256,     322,     -47,     256,     322,      -5,
     -29,      -8,     -15,     256,     -11,     -27,     -49,     343,
     345,     -64,     -41,     -47,     256,     -48,     256,     320,
     346,     346,     -26,     256,     -12,     305,     -25,     270,
     -81,     -83,     -82,     -82,     -87,     -90,     -91,     -91,
     -91,     -91,     -91,     -91,     -91,     -91,     -91,     -91,
     -42,     -63,     305,     287,     -92,     346,     -82,     346,
     346,     256,     -49,     -27,     -63,     -39,     -39,     -63,
     -14,     344,     -65,     -59,     320,     -40,     320,     297,
     323,     -10,     -13,     343,     345,     -15,     -11,     -15,
     -48,     256,     -46,     -47,     256,     -18,     319,     322,
     319,     256,     322,     323,     -51,     -52,      -3,     343,
     -82,     -82,     -88,     -91,     344,     346,     322,     -42,
     346,     346,     346,     346,     346,     256,     -66,     -60,
      -2,     -16,     297,     -48,     256,     -46,     -47,     256,
     -18,     346,     256,     -48,     256,     -47,     256,     -41,
     -12,     -46,     256,     319,     -53,     -54,     256,     -23,
      -8,     326,     -27,     -49,     -46,     326,     -92,     319,
     -67,     256,     -63,     -68,     307,     320,     308,     -69,
     310,     311,     312,     309,     315,     317,     316,     313,
     314,     276,     275,     274,     272,     273,     305,     256,
     -61,     -62,      -7,      -9,      -8,     -48,     256,     -47,
     256,     320,     256,     -40,     320,     326,     -46,     344,
     -84,     320,     -38,     320,     -63,     -69,     305,     326,
     345,     -46,     326,     345,     345,     345,     -78,     320,
     320,     -38,     -38,     345,     345,     320,     -40,     320,
     323,     -23,     -46,     256,     -82,     320,     320,     -70,
     -63,     326,     -72,     -80,     -72,     -75,     -63,     -67,
     -63,     -39,      -7,     -41,     256,     -67,     346,     346,
     -63,     346,     320,     315,     346,     346,     -71,     -67,
     -74,     -72,     -79,     -38,     320,     -38,     306,     -67,
     320,     345,     -73,     -76,     -72,     -67,     -75,     346,
     346,     320,     -77,     -67,
};

const int yydef[] = {
       3,      -2,      -2,       2,       7,       0,      -2,      31,
      37,      38,      39,      40,      41,      42,      43,      44,
      45,      46,       0,       0,       0,      53,      93,      94,
      95,      96,      97,       0,       4,       0,       0,      -2,
      12,       0,       0,      65,      14,      87,      82,      79,
      81,       0,      32,      33,      26,       0,      48,      59,
      50,     151,      52,       0,       0,     101,     177,     178,
       5,       6,       0,      23,       8,      -2,      22,       0,
       0,     167,      74,     102,       0,      65,      83,      84,
       0,      -2,       0,       0,       0,      -2,       0,      88,
      89,      90,       0,     303,       0,       0,      -2,       0,
     149,      -2,       0,     245,     248,     254,     255,     258,
     259,     262,     273,      -2,     275,     276,     277,     278,
     279,       0,       0,     283,     284,       0,       0,       0,
       0,       0,       0,       0,      13,      24,      25,      21,
       0,     166,      -2,     103,     104,       0,      77,     109,
     110,      85,     169,       0,       0,       0,       0,      75,
      76,      80,     107,     108,     111,     112,       0,       0,
     117,     119,      -2,     122,     123,      34,      15,      16,
     199,       0,      17,      18,      19,      20,      66,      67,
       0,      70,      71,       0,      91,      92,       0,     304,
       0,       0,       0,     154,      98,     246,     249,       0,
       0,     256,     260,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,     293,       0,
       0,     300,       0,       0,       0,      -2,       0,       0,
      -2,     291,     292,     294,     295,     296,       0,      10,
     188,     179,       0,       0,     183,     185,     186,      78,
     105,     106,       0,     170,     171,     172,     173,     174,
     175,     113,     114,       0,     115,     116,      -2,      35,
      36,     121,     124,     126,      65,     130,       0,       0,
      -2,       0,     201,      68,      69,      72,      73,      11,
      27,      28,       0,      56,      60,      62,      -2,       0,
       0,       0,     252,     253,       0,       0,     263,     264,
     265,     266,     267,     268,     269,     270,     271,     272,
     281,       0,     298,     299,       0,     302,     305,     274,
       0,     290,       0,     130,       0,       0,     284,       0,
       0,      99,     206,      -2,     180,       0,     182,      86,
       0,     118,     120,       0,      -2,     129,      65,       0,
     135,     136,       0,     143,     144,       0,     200,       0,
      54,      55,       0,       0,       0,     153,     157,       0,
     247,       0,     257,     261,     297,     301,       0,     289,
     280,     282,     285,     286,     287,     288,     209,     187,
      -2,     184,     176,     131,     132,       0,     139,     140,
       0,     127,     128,     137,     138,     145,     146,     202,
      61,      63,      64,     148,       0,       0,     159,     160,
     162,       0,       0,       0,       0,     250,     306,     203,
     205,     207,       0,       0,       0,     213,       0,       0,
       0,       0,       0,       0,       0,       0,     229,       0,
       0,       0,       0,       0,     237,       0,      -2,     189,
       0,       0,     193,     195,     196,     133,     134,     141,
     142,     155,     156,       0,     158,       0,     165,     100,
       0,     208,     210,     211,       0,       0,     242,     215,
       0,       0,     220,      -2,      -2,     244,     209,     232,
     233,     234,     235,       0,       0,     190,       0,     192,
       0,     161,     163,     164,     251,     212,     214,     209,
       0,     219,       0,       0,       0,       0,     243,       0,
       0,       0,     194,     197,     198,     216,     217,     209,
     240,     224,      -2,     230,       0,       0,       0,     221,
     209,       0,       0,     236,     238,     218,     222,     225,
     226,      -2,     209,     244,       0,     223,       0,       0,
     227,     231,     209,     228,
};

/*****************************************************************/
/* PCYACC LALR parser driver routine -- a table driven procedure */
/* for recognizing sentences of a language defined by the        */
/* grammar that PCYACC analyzes. An LALR parsing table is then   */
/* constructed for the grammar and the skeletal parser uses the  */
/* table when performing syntactical analysis on input source    */
/* programs. The actions associated with grammar rules are       */
/* inserted into a switch statement for execution.               */
/*****************************************************************/


#ifndef YYMAXDEPTH
#define YYMAXDEPTH 200
#endif
#ifndef YYREDMAX
#define YYREDMAX 1000
#endif
#define PCYYFLAG -4096
#define WAS0ERR 0
#define WAS1ERR 1
#define WAS2ERR 2
#define WAS3ERR 3
#define yyclearin pcyytoken = -1
#define yyerrok   pcyyerrfl = 0
YYSTYPE yyv[YYMAXDEPTH];     /* value stack */
int pcyyerrct = 0;           /* error count */
int pcyyerrfl = 0;           /* error flag */
int redseq[YYREDMAX];
int redcnt = 0;
int pcyytoken = -1;          /* input token */


yyparse()
{
#ifdef YYSHORT
  const short *yyxi;
#else
  const int *yyxi;
#endif
#ifdef YYASTFLAG
    int ti; int tj;
#endif

#ifdef YYDEBUG
int tmptoken;
#endif
  int statestack[YYMAXDEPTH]; /* state stack */
  int      j, m;              /* working index */
  YYSTYPE *yypvt;
  int      tmpstate, *yyps, n;
  YYSTYPE *yypv;


  tmpstate = 0;
  pcyytoken = -1;


#ifdef YYDEBUG
  tmptoken = -1;
#endif


  pcyyerrct = 0;
  pcyyerrfl = 0;
  yyps = &statestack[-1];
  yypv = &yyv[-1];


  enstack:    /* push stack */
#ifdef YYDEBUG
    printf("at state %d, next token %d\n", tmpstate, tmptoken);
#endif
    if (++yyps - &statestack[YYMAXDEPTH-1] > 0) {
      yyerror("pcyacc internal stack overflow");
      return(1);
    }
    *yyps = tmpstate;
    ++yypv;
    *yypv = yyval;


  newstate:
    n = yypact[tmpstate];
    if (n <= PCYYFLAG) goto defaultact; /*  a simple state */


    if (pcyytoken < 0) if ((pcyytoken=yylex()) < 0) pcyytoken = 0;
    if ((n += pcyytoken) < 0 || n >= YYLAST) goto defaultact;


    if (yychk[n=yyact[n]] == pcyytoken) { /* a shift */
#ifdef YYDEBUG
      tmptoken  = pcyytoken;
#endif
      pcyytoken = -1;
      yyval = yylval;
      tmpstate = n;
      if (pcyyerrfl > 0) --pcyyerrfl;
      goto enstack;
    }


  defaultact:


    if ((n=yydef[tmpstate]) == -2) {
      if (pcyytoken < 0) if ((pcyytoken=yylex())<0) pcyytoken = 0;
      for (yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=tmpstate); yyxi += 2);
      while (*(yyxi+=2) >= 0) if (*yyxi == pcyytoken) break;
      if ((n=yyxi[1]) < 0) { /* an accept action */
#ifdef YYASTFLAG
          yytfilep = fopen(yytfilen, "w");
          if (yytfilep == NULL) {
            fprintf(stderr, "Can't open t file: %s\n", yytfilen);
            return(0);          }
          for (ti=redcnt-1; ti>=0; ti--) {
            tj = svdprd[redseq[ti]];
            while (strcmp(svdnams[tj], "$EOP"))
              fprintf(yytfilep, "%s ", svdnams[tj++]);
            fprintf(yytfilep, "\n");
          }
          fclose(yytfilep);
#endif

        return (0);
      }
    }


    if (n == 0) {        /* error situation */
      switch (pcyyerrfl) {
        case WAS0ERR:          /* an error just occurred */
          yyerror("syntax error");
            ++pcyyerrct;
        case WAS1ERR:
        case WAS2ERR:           /* try again */
          pcyyerrfl = 3;
	   /* find a state for a legal shift action */
          while (yyps >= statestack) {
	     n = yypact[*yyps] + YYERRCODE;
	     if (n >= 0 && n < YYLAST && yychk[yyact[n]] == YYERRCODE) {
	       tmpstate = yyact[n];  /* simulate a shift of "error" */
	       goto enstack;
            }
	     n = yypact[*yyps];


	     /* the current yyps has no shift on "error", pop stack */
#ifdef YYDEBUG
            printf("error: pop state %d, recover state %d\n", *yyps, yyps[-1]);
#endif
	     --yyps;
	     --yypv;
	   }


	   yyabort:

#ifdef YYASTFLAG
              yytfilep = fopen(yytfilen, "w");
              if (yytfilep == NULL) {
                fprintf(stderr, "Can't open t file: %s\n", yytfilen);
                return(1);              }
              for (ti=1; ti<redcnt; ti++) {
                tj = svdprd[redseq[ti]];
                while (strcmp(svdnams[tj], "$EOP"))
                  fprintf(yytfilep, "%s ", svdnams[tj++]);
                fprintf(yytfilep, "\n");
              }
              fclose(yytfilep);
#endif

	     return(1);


	 case WAS3ERR:  /* clobber input char */
#ifdef YYDEBUG
          printf("error: discard token %d\n", pcyytoken);
#endif
          if (pcyytoken == 0) goto yyabort; /* quit */
	   pcyytoken = -1;
	   goto newstate;      } /* switch */
    } /* if */


    /* reduction, given a production n */
#ifdef YYDEBUG
    printf("reduce with rule %d\n", n);
#endif
#ifdef YYASTFLAG
    if ( redcnt<YYREDMAX ) redseq[redcnt++] = n;
#endif
    yyps -= yyr2[n];
    yypvt = yypv;
    yypv -= yyr2[n];
    yyval = yypv[1];
    m = n;
    /* find next state from goto table */
    n = yyr1[n];
    j = yypgo[n] + *yyps + 1;
    if (j>=YYLAST || yychk[ tmpstate = yyact[j] ] != -n) tmpstate = yyact[yypgo[n]];
    switch (m) { /* actions associated with grammar rules */
      
      case 1:{} break;
      case 3:{ /* initializations */
      		  typDfAllowed = TRUE;
              FSLexInit();
      		} break;
      case 4:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               if ( pcyytoken == NAME ) delete [] yylval.ptrChar;
               while ( ( pcyytoken = yylex() ) != SEMI && pcyytoken != EOF )
               {
                  if ( pcyytoken == NAME ) delete [] yylval.ptrChar;
               }
               if ( pcyytoken == SEMI ) pcyytoken = yylex();
               if ( pcyytoken == EOF ) pcyytoken = 0;
               delete yypvt[-1].ptrType;
            } break;
      case 6:{
              FSAnzError( E_INV_DECL );
              yyerrok;
            } break;
      case 7:{ typDfAllowed = TRUE; } break;
      case 8:{ delete yypvt[-2].ptrType;
      		} break;
      case 9:{ yypvt[-1].ptrSym = FSAppendType( yypvt[-2].ptrType, yypvt[-1].ptrSym);
                fsSymTable->Insert( yypvt[-1].ptrSym );
      		  fsSymTable->EnterScope();
      		  FSInsertSymListtoTable(*fsSymTable,*( ((FSFunctType *)(yypvt[-1].ptrSym->GetType()))->GetArgs() ));
      		} break;
      case 10:{
      		  fsSymTable->LeaveScope();
      		} break;
      case 12:{ yypvt[-0].ptrSym = FSAppendType( yypvt[-1].ptrType, yypvt[-0].ptrSym, (yychar == COMMA) ? typDfAllowed = FALSE, FS_SPEC_COPY : FS_NO_SPEC_COPY);
               if ( yychar != COMMA ) yypvt[-1].ptrType = 0;
      		  fsSymTable->Insert( yypvt[-0].ptrSym );
      		} break;
      case 13:{ yypvt[-0].ptrSym = FSAppendType( yypvt[-3].ptrType, yypvt[-0].ptrSym, (yychar == COMMA) ? typDfAllowed = FALSE, FS_SPEC_COPY : FS_NO_SPEC_COPY);
               if ( yychar != COMMA ) yypvt[-3].ptrType = 0;
      		  fsSymTable->Insert( yypvt[-0].ptrSym );
      		} break;
      case 15:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yypvt[-2].ptrSym->SetDef( FS_DEFINED );
            } break;
      case 16:{ yypvt[-2].ptrSym->SetDef(FS_DEFINED);
      		} break;
      case 17:{ yypvt[-2].ptrSym->SetDef(FS_DEFINED);
      		} break;
      case 18:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yypvt[-2].ptrSym->SetDef( FS_DEFINED );
            } break;
      case 19:{ yypvt[-2].ptrSym->SetDef(FS_DEFINED);
      		} break;
      case 20:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yypvt[-2].ptrSym->SetDef( FS_DEFINED );
            } break;
      case 22:{
               FSAnzError( E_INV_DECL );
               yyerrok;
            } break;
      case 28:{ if ( yypvt[-1].spec != FS_VOID ) FSAnzError( E_INV_DECL );
            } break;
      case 30:{ yyval.ptrType = new FSBaseType(FS_INT);
      		} break;
      case 32:{ yyval.ptrType = FSBaseType::Merge(yypvt[-1].ptrType,yypvt[-0].ptrType);
      		} break;
      case 35:{ yyval.ptrType = FSBaseType::Merge(yypvt[-1].ptrType,yypvt[-0].ptrType);
      		} break;
      case 38:{ yyval.ptrType = new FSBaseType(yypvt[-0].spec);
      		} break;
      case 39:{ yyval.ptrType = new FSBaseType(yypvt[-0].spec);
      		} break;
      case 40:{ yyval.ptrType = new FSBaseType(yypvt[-0].spec);
      		  ((FSBaseType *)(yyval.ptrType))->CheckTypeDef(typDfAllowed);
      		} break;
      case 41:{ yyval.ptrType = new FSBaseType(yypvt[-0].spec);
      		  ((FSBaseType *)(yyval.ptrType))->CheckTypeDef(typDfAllowed);
      		} break;
      case 42:{ yyval.ptrType = new FSBaseType(yypvt[-0].spec);
      		  ((FSBaseType *)(yyval.ptrType))->CheckTypeDef(typDfAllowed);
      		} break;
      case 43:{ yyval.ptrType = new FSBaseType(yypvt[-0].spec);
      		  ((FSBaseType *)(yyval.ptrType))->CheckTypeDef(typDfAllowed);
      		} break;
      case 44:{ yyval.ptrType = new FSBaseType(yypvt[-0].spec);
      		  ((FSBaseType *)(yyval.ptrType))->CheckTypeDef(typDfAllowed);
      		} break;
      case 45:{ yyval.ptrType = new FSBaseType(yypvt[-0].spec);
      		  ((FSBaseType *)(yyval.ptrType))->CheckTypeDef(typDfAllowed);
      		} break;
      case 46:{ yyval.ptrType = new FSBaseType(yypvt[-0].spec);
      		  ((FSBaseType *)(yyval.ptrType))->CheckTypeDef(typDfAllowed);
      		} break;
      case 47:{ typDfAllowed = FALSE; } break;
      case 48:{ yyval.ptrType = yypvt[-0].ptrType;
      		} break;
      case 49:{ typDfAllowed = FALSE; } break;
      case 50:{ yyval.ptrType = yypvt[-0].ptrType;
      		} break;
      case 51:{ typDfAllowed = FALSE; } break;
      case 52:{ yyval.ptrType= yypvt[-0].ptrSym->GetType()->Copy();
      		  ((FSBaseType *)(yyval.ptrType->GetBaseType()))->RemoveSpecifier(FS_TYPEDEF);
      		} break;
      case 53:{ yyval.ptrType = new FSBaseType(yypvt[-0].spec);
      		  ((FSBaseType *)(yyval.ptrType))->CheckTypeDef(typDfAllowed);
            } break;
      case 54:{ FSSymbol *oldSym = yypvt[-3].ptrSym;
      		  fsSymTable->InsertStrUnEnum(&oldSym);
      		  if (oldSym == yypvt[-3].ptrSym)
              {
      		    ((FSStrUnEnumDefType *)(oldSym->GetType()))->SetMembers(yypvt[-1].ptrSymList);
      		    FSInsertSymListtoTable(*fsSymTable, *(yypvt[-1].ptrSymList));
      		    yyval.ptrType = new FSStrUnEnumType(FS_T_ENUM,oldSym);
      		  }
      		  else
              {
                 FSAnzError( E_MULT_DEF_s, oldSym->GetId() );
      		     delete yypvt[-1].ptrSymList;
      		    //YYERROR; already defined
      		  }
      		} break;
      case 55:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               FSSymbol *oldSym = yypvt[-3].ptrSym;
      		  fsSymTable->InsertStrUnEnum(&oldSym);
      		  if (oldSym == yypvt[-3].ptrSym) {
      		    ((FSStrUnEnumDefType *)(oldSym->GetType()))->SetMembers(yypvt[-1].ptrSymList);
      		    FSInsertSymListtoTable(*fsSymTable, *(yypvt[-1].ptrSymList));
      		    yyval.ptrType = new FSStrUnEnumType(FS_T_ENUM,oldSym);
      		  }
      		  else {
      		    delete yypvt[-1].ptrSymList;
      		    //YYERROR; already defined
      		  }
      		} break;
      case 56:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               FSSymbol *oldSym = yypvt[-2].ptrSym;
      		   fsSymTable->InsertStrUnEnum(&oldSym);
      		   if (oldSym != yypvt[-2].ptrSym)
               {
                  FSAnzError( E_MULT_DEF_s, oldSym->GetId() );
               }
      		    yyval.ptrType = new FSStrUnEnumType(FS_T_ENUM,oldSym);
      		} break;
      case 57:{ FSSymbol *pSym;
      		  if ( fsSymTable->LookUpStrUnEnum( yypvt[-0].ptrChar, &pSym ) == TRUE )
              {
                  yyval.ptrType = new FSStrUnEnumType( FS_T_ENUM, pSym );
      		  }
      		  else
              {
                pSym = new FSSymbol( yypvt[-0].ptrChar, FS_NO_ID_COPY, new FSStrUnEnumDefType( FS_T_ENUM ) );
                fsSymTable->InsertStrUnEnum( &pSym );
                yyval.ptrType = new FSStrUnEnumType( FS_T_ENUM, pSym );
      		  }
      		} break;
      case 58:{ yyval.ptrSym = new FSSymbol(yypvt[-0].ptrChar,FS_NO_ID_COPY,new FSStrUnEnumDefType(FS_T_ENUM),FS_DEFINED);
      		} break;
      case 59:{ yyval.ptrSym = new FSSymbol(FSUniqueName(),FS_ID_COPY,new FSStrUnEnumDefType(FS_T_ENUM),FS_DEFINED);
      		} break;
      case 60:{ yypvt[-0].ptrSym->SetType( new FSStrUnEnumType(FS_T_ENUM,yypvt[-2].ptrSym,FS_CONST) );
      		  yyval.ptrSymList = new FSSymbolList;
      		  yyval.ptrSymList->Append(yypvt[-0].ptrSym);
      		} break;
      case 61:{ /* $$ = $1 */
      		  yypvt[-0].ptrSym->SetType( new FSStrUnEnumType(FS_T_ENUM,yypvt[-4].ptrSym,FS_CONST) );
      		  yyval.ptrSymList->Append(yypvt[-0].ptrSym);
      		} break;
      case 62:{ yyval.ptrSym = new FSSymbol(yypvt[-0].ptrChar,FS_NO_ID_COPY,0,FS_DEFINED);
      		} break;
      case 63:{ yyval.ptrSym = new FSSymbol(yypvt[-2].ptrChar,FS_NO_ID_COPY,0,FS_DEFINED);
      		} break;
      case 64:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = new FSSymbol(yypvt[-2].ptrChar,FS_NO_ID_COPY,0,FS_DEFINED);
      		} break;
      case 66:{ yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR), yypvt[-2].ptrSym );
      		} break;
      case 67:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR), yypvt[-2].ptrSym );
      		} break;
      case 68:{ yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_ANSI,yypvt[-1].ptrSymList), yypvt[-3].ptrSym );
      		} break;
      case 69:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_ANSI,yypvt[-1].ptrSymList), yypvt[-3].ptrSym );
      		} break;
      case 70:{ yyval.ptrSym = FSAppendType(new FSArrType(FS_NO_DIM_PRESENT), yypvt[-2].ptrSym );
      		} break;
      case 71:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSArrType(FS_NO_DIM_PRESENT), yypvt[-2].ptrSym );
      		} break;
      case 72:{ yyval.ptrSym = FSAppendType(new FSArrType(FS_DIM_PRESENT), yypvt[-3].ptrSym );
      		} break;
      case 73:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSArrType(FS_DIM_PRESENT), yypvt[-3].ptrSym );
      		} break;
      case 74:{ yyval.ptrSym = FSAppendType(new FSPtrType(yypvt[-1].spec), yypvt[-0].ptrSym);
      		} break;
      case 75:{ yyval.ptrSym = yypvt[-1].ptrSym; } break;
      case 76:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = yypvt[-1].ptrSym;
            } break;
      case 80:{ yyval.ptrSym = yypvt[-1].ptrSym;
      		} break;
      case 81:{ yyval.ptrSym = new FSSymbol( yypvt[-0].ptrChar,FS_NO_ID_COPY );
                typDfAllowed = TRUE;
      		} break;
      case 87:{ yyval.spec = FS_NOTYPE; } break;
      case 88:{ yyval.spec = yypvt[-0].spec; } break;
      case 91:{ yyval.spec = (FSBaseTypeSpecifiers)(yypvt[-1].spec | yypvt[-0].spec); } break;
      case 92:{ yyval.spec = (FSBaseTypeSpecifiers)(yypvt[-1].spec | yypvt[-0].spec); } break;
      case 101:{ yyval.spec = FS_NOTYPE; } break;
      case 102:{ yyval.ptrSym = FSAppendType(new FSPtrType(yypvt[-1].spec),yypvt[-0].ptrSym);
      		} break;
      case 103:{ yyval.ptrSym = FSAppendType(new FSArrType(FS_NO_DIM_PRESENT),yypvt[-2].ptrSym);
      		} break;
      case 104:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSArrType(FS_NO_DIM_PRESENT),yypvt[-2].ptrSym);
      		} break;
      case 105:{ yyval.ptrSym = FSAppendType(new FSArrType(FS_DIM_PRESENT),yypvt[-3].ptrSym);
      		} break;
      case 106:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSArrType(FS_DIM_PRESENT),yypvt[-3].ptrSym);
      		} break;
      case 107:{ yyval.ptrSym = yypvt[-1].ptrSym; } break;
      case 108:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = yypvt[-1].ptrSym;
            } break;
      case 109:{ yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR),yypvt[-2].ptrSym);
      		} break;
      case 110:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR),yypvt[-2].ptrSym);
      		} break;
      case 111:{ yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR),yypvt[-2].ptrSym);
      		} break;
      case 112:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR),yypvt[-2].ptrSym);
      		} break;
      case 113:{ yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR,yypvt[-1].ptrSymList),yypvt[-3].ptrSym);
      		} break;
      case 114:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR,yypvt[-1].ptrSymList),yypvt[-3].ptrSym);
      		} break;
      case 115:{ yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_ANSI,yypvt[-1].ptrSymList),yypvt[-3].ptrSym);
      		} break;
      case 116:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_ANSI,yypvt[-1].ptrSymList),yypvt[-3].ptrSym);
      		} break;
      case 117:{ yyval.ptrSymList = new FSSymbolList;
              yypvt[-0].ptrSym->SetType( new FSBaseType( FS_INT ) );
      		  yyval.ptrSymList->Append(yypvt[-0].ptrSym);
      		} break;
      case 118:{  /* $$ = $1 */
               yypvt[-0].ptrSym->SetType( new FSBaseType( FS_INT ) );
               yyval.ptrSymList->Append(yypvt[-0].ptrSym);
      		} break;
      case 119:{ yyval.ptrSymList = new FSSymbolList;
      		  if ( yypvt[-0].ptrSym ) yyval.ptrSymList->Append(yypvt[-0].ptrSym);
      		} break;
      case 120:{ /* $$ = $1 */ if ( yypvt[-0].ptrSym ) yyval.ptrSymList->Append(yypvt[-0].ptrSym);
      		} break;
      case 121:{ yyval.ptrSym = FSAppendType( yypvt[-1].ptrType, yypvt[-0].ptrSym );
      		} break;
      case 123:{ /* treba uvesti neki flag u FunctType */
      	      yyval.ptrSym = 0;
      		} break;
      case 124:{ yyval.ptrSym = FSAppendType( yypvt[-1].ptrType, yypvt[-0].ptrSym );
               typDfAllowed = TRUE;
      		} break;
      case 125:{ yyval.ptrSym = FSAppendType( yypvt[-0].ptrType, new FSSymbol("(abstract)") );
                typDfAllowed = TRUE;
      		} break;
      case 126:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType( yypvt[-1].ptrType, new FSSymbol("(abstract)") );
                typDfAllowed = TRUE;
      		} break;
      case 127:{
               yyval.ptrSym = yypvt[-1].ptrSym;
      		} break;
      case 128:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = yypvt[-1].ptrSym;
      		} break;
      case 129:{ yyval.ptrSym = FSAppendType(new FSPtrType(yypvt[-1].spec), yypvt[-0].ptrSym );
      		} break;
      case 130:{ yyval.ptrSym = FSAppendType(new FSPtrType(yypvt[-0].spec), new FSSymbol("(abstract)") );
      		} break;
      case 131:{ yyval.ptrSym = FSAppendType(new FSArrType(FS_NO_DIM_PRESENT),yypvt[-2].ptrSym);
      		} break;
      case 132:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSArrType(FS_NO_DIM_PRESENT),yypvt[-2].ptrSym);
      		} break;
      case 133:{ yyval.ptrSym = FSAppendType(new FSArrType(FS_DIM_PRESENT),yypvt[-3].ptrSym);
      		} break;
      case 134:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSArrType(FS_DIM_PRESENT),yypvt[-3].ptrSym);
      		} break;
      case 135:{ yyval.ptrSym = FSAppendType(new FSArrType(FS_NO_DIM_PRESENT),new FSSymbol("(abstract)"));
      		} break;
      case 136:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSArrType(FS_NO_DIM_PRESENT),new FSSymbol("(abstract)"));
      		} break;
      case 137:{ yyval.ptrSym = FSAppendType(new FSArrType(FS_DIM_PRESENT),new FSSymbol("(abstract)"));
      		} break;
      case 138:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSArrType(FS_DIM_PRESENT),new FSSymbol("(abstract)"));
      		} break;
      case 139:{ yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR), yypvt[-2].ptrSym);
      		} break;
      case 140:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR), yypvt[-2].ptrSym);
      		} break;
      case 141:{ yyval.ptrSym = FSAppendType(new FSFunctType( FS_S_ANSI, yypvt[-1].ptrSymList ), yypvt[-3].ptrSym);
      		} break;
      case 142:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSFunctType( FS_S_ANSI, yypvt[-1].ptrSymList ), yypvt[-3].ptrSym);
      		} break;
      case 143:{ yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR), new FSSymbol("(abstract)") );
      		} break;
      case 144:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSFunctType(FS_S_KR), new FSSymbol("(abstract)") );
      		} break;
      case 145:{ yyval.ptrSym = FSAppendType(new FSFunctType( FS_S_ANSI, yypvt[-1].ptrSymList ), new FSSymbol("(abstract)") );
      		} break;
      case 146:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yyval.ptrSym = FSAppendType(new FSFunctType( FS_S_ANSI, yypvt[-1].ptrSymList ), new FSSymbol("(abstract)") );
      		} break;
      case 147:{ typDfAllowed = FALSE; } break;
      case 148:{
              if (yypvt[-4].ptrSym->Defined() == FS_DEFINED )
              {
      		    FSAnzError( E_MULT_DEF_s, yypvt[-4].ptrSym->GetId() );
      		    delete yypvt[-2].ptrSymList;
      		  }
      		  else
              {
                  ((FSStrUnEnumDefType *)(yypvt[-4].ptrSym->GetType()))->SetMembers(yypvt[-2].ptrSymList);
                   yypvt[-4].ptrSym->SetDef(FS_DEFINED);
              }
      		  yyval.ptrType = new FSStrUnEnumType(yypvt[-5].typId,yypvt[-4].ptrSym);
      		} break;
      case 149:{  yyval.ptrType = new FSStrUnEnumType(yypvt[-1].typId,yypvt[-0].ptrSym);
      		} break;
      case 150:{ yyval.ptrSym = new FSSymbol(yypvt[-0].ptrChar,FS_NO_ID_COPY, new FSStrUnEnumDefType(yypvt[-1].typId));
      		  fsSymTable->InsertStrUnEnum(&(yyval.ptrSym));
      		  typDfAllowed = TRUE; /* lookahead is already scanned, but it is { */
      		} break;
      case 151:{ yyval.ptrSym = new FSSymbol(FSUniqueName(),FS_ID_COPY,new FSStrUnEnumDefType(yypvt[-0].typId));
      		  fsSymTable->InsertStrUnEnum(&(yyval.ptrSym));
      		  typDfAllowed = TRUE; /* lookahead is already scanned, but it is { */
      		} break;
      case 152:{ if (fsSymTable->LookUpStrUnEnum(yypvt[-0].ptrChar,&(yyval.ptrSym)) == FALSE)
              {
      		    /* install a new uncomplete type at the current level */
      		    yyval.ptrSym = new FSSymbol(yypvt[-0].ptrChar,FS_NO_ID_COPY,new FSStrUnEnumDefType(yypvt[-1].typId));
      		    fsSymTable->InsertStrUnEnum(&yyval.ptrSym);
      		  }
              else
              {
               delete [] yypvt[-0].ptrChar;
              }
      		} break;
      case 154:{
               yyval.ptrSymList = new FSSymbolList;
      		} break;
      case 156:{
               FSAnzError( E_INV_DECL );
               yyerrok;
            } break;
      case 157:{ typDfAllowed = TRUE; } break;
      case 158:{ delete yypvt[-2].ptrType;
      		  FSAnzError( E_INV_STRUCT_ELEM );
      		} break;
      case 159:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               if ( pcyytoken == NAME ) delete [] yylval.ptrChar;
               while ( ( pcyytoken = yylex() ) != SEMI && pcyytoken != RC && pcyytoken != EOF )
               {
                  if ( pcyytoken == NAME ) delete [] yylval.ptrChar;
               }
               if ( pcyytoken == SEMI ) pcyytoken = yylex();
               if ( pcyytoken == EOF ) pcyytoken = 0;
               delete yypvt[-1].ptrType;
      		} break;
      case 160:{ yypvt[-0].ptrSym = FSAppendType(yypvt[-1].ptrType, yypvt[-0].ptrSym, (yychar == COMMA ) ? typDfAllowed = FALSE, FS_SPEC_COPY : FS_NO_SPEC_COPY );
              if ( yychar != COMMA ) yypvt[-1].ptrType = 0;
      		  yypvt[-2].ptrSymList ->Append( yypvt[-0].ptrSym );
      		} break;
      case 161:{ yypvt[-0].ptrSym = FSAppendType(yypvt[-3].ptrType, yypvt[-0].ptrSym, (yychar == COMMA ) ? typDfAllowed = FALSE, FS_SPEC_COPY : FS_NO_SPEC_COPY );
               if ( yychar != COMMA ) yypvt[-3].ptrType = 0;
      		  yypvt[-4].ptrSymList ->Append( yypvt[-0].ptrSym );
      		} break;
      case 164:{ /* $$ = $1 */
               FSAnzError( E_INV_STRUCT_ELEM );
               yyerrok;
            } break;
      case 165:{
               yyval.ptrSym = new FSSymbol(FSUniqueName(), FS_ID_COPY, new FSBaseType( FS_INT ) );
               typDfAllowed = TRUE;
            } break;
      case 177:{ delete [] yypvt[-0].ptrChar; } break;
      case 179:{
               FSAnzError( E_INV_PARAM_DECL );
               yyerrok;
               if ( pcyytoken == NAME ) delete [] yylval.ptrChar;
               while ( ( pcyytoken = yylex() ) != SEMI && pcyytoken != EOF )
               {
                  if ( pcyytoken == NAME ) delete [] yylval.ptrChar;
               }
               if ( pcyytoken == SEMI ) pcyytoken = yylex();
               if ( pcyytoken == EOF ) pcyytoken = 0;
               delete yypvt[-1].ptrType;
            } break;
      case 181:{ typDfAllowed = TRUE; } break;
      case 182:{
      		  FSTypeId type = yypvt[-2].ptrType->GetId();
              if ( type != FS_T_STRUCT && type != FS_T_UNION && type != FS_T_ENUM )
                  FSAnzError( E_INV_PARAM_DECL );
              delete yypvt[-2].ptrType;
      		} break;
      case 183:{ yypvt[-0].ptrSym = FSAppendType(yypvt[-1].ptrType, yypvt[-0].ptrSym, (yychar == COMMA ) ? typDfAllowed = FALSE, FS_SPEC_COPY : FS_NO_SPEC_COPY );
               if ( yychar != COMMA ) yypvt[-1].ptrType = 0;
      		  FSPatchArgs(yypvt[-3].ptrSym, yypvt[-0].ptrSym );
      		} break;
      case 184:{ yypvt[-0].ptrSym = FSAppendType(yypvt[-3].ptrType, yypvt[-0].ptrSym, (yychar == COMMA ) ? typDfAllowed = FALSE, FS_SPEC_COPY : FS_NO_SPEC_COPY );
               if ( yychar != COMMA ) yypvt[-3].ptrType = 0;
      		  FSPatchArgs( yypvt[-5].ptrSym, yypvt[-0].ptrSym );
      		} break;
      case 189:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               if ( pcyytoken == NAME ) delete [] yylval.ptrChar;
               while ( ( pcyytoken = yylex() ) != SEMI && pcyytoken != EOF )
               {
                  if ( pcyytoken == NAME ) delete [] yylval.ptrChar;
               }
               if ( pcyytoken == SEMI ) pcyytoken = yylex();
               if ( pcyytoken == EOF ) pcyytoken = 0;
               delete yypvt[-1].ptrType;
            } break;
      case 191:{ typDfAllowed = TRUE; } break;
      case 192:{
              FSTypeId type = yypvt[-2].ptrType->GetId();
      		  if ( type != FS_T_STRUCT && type != FS_T_UNION && type != FS_T_ENUM )
                  FSAnzError( E_INV_DECL );
              delete yypvt[-2].ptrType;
      		} break;
      case 193:{ yypvt[-0].ptrSym = FSAppendType(yypvt[-1].ptrType, yypvt[-0].ptrSym, (yychar == COMMA ) ? typDfAllowed = FALSE, FS_SPEC_COPY : FS_NO_SPEC_COPY );
               if ( yychar != COMMA ) yypvt[-1].ptrType = 0;
      		  fsSymTable->Insert( yypvt[-0].ptrSym );
      		} break;
      case 194:{ yypvt[-0].ptrSym = FSAppendType(yypvt[-3].ptrType, yypvt[-0].ptrSym, (yychar == COMMA ) ? typDfAllowed = FALSE, FS_SPEC_COPY : FS_NO_SPEC_COPY );
               if ( yychar != COMMA ) yypvt[-3].ptrType = 0;
      		  fsSymTable->Insert( yypvt[-0].ptrSym );
      		} break;
      case 197:{ yypvt[-2].ptrSym->SetDef(FS_DEFINED);
      		} break;
      case 198:{
               FSAnzError( E_INV_DECL );
               yyerrok;
               yypvt[-2].ptrSym->SetDef(FS_DEFINED);
      		} break;
      case 207:{
               FSAnzError( E_INV_STMT );
               yyerrok;
               if ( pcyytoken == NAME ) delete [] yylval.ptrChar;
               while (    ( pcyytoken = yylex() ) != SEMI
                       && pcyytoken != EOF
                       && pcyytoken != LC
                       && pcyytoken != RC
                     )
               {
                  if ( pcyytoken == NAME ) delete [] yylval.ptrChar;
               }
               if ( pcyytoken == SEMI ) pcyytoken = yylex();
               if ( pcyytoken == EOF ) pcyytoken = 0;
            } break;
      case 209:{fsSymTable->EnterScope();
      		} break;
      case 210:{fsSymTable->LeaveScope();
      		} break;
      case 215:{} break;
      case 217:{ fsSymTable->EnterScope();
      		} break;
      case 218:{ fsSymTable->LeaveScope();
      		} break;
      case 222:{} break;
      case 224:{} break;
      case 226:{} break;
      case 227:{} break;
      case 229:{} break;
      case 230:{} break;
      case 239:{} break;
      case 242:{ delete [] yypvt[-0].ptrChar; } break;
      case 246:{} break;
      case 249:{} break;
      case 250:{} break;
      case 256:{} break;
      case 260:{} break;
      case 283:{
               FSSymbol *pSym;
               if ( fsSymTable->LookUp( yypvt[-0].ptrChar, &pSym ) )
               {
                   /* pSym->GetLevel() == FS_EXT_DECL za globalne simbole, ostalo su lokalni */
                   /* pSym->FirstUseInCurrFunc() == TRUE za prvu upotrebu, FALSE za sledece */
                   pSym->SetFirstUseInCurrFunc( FALSE );
               }
               delete [] yypvt[-0].ptrChar;
      		} break;
      case 287:{
               delete yypvt[-1].ptrSym;
            } break;
      case 288:{
               FSAnzError( E_INV_EXPR );
               yyerrok;
               delete yypvt[-1].ptrSym;
            } break;
      case 289:{
               delete yypvt[-2].ptrSym;
            } break;
      case 290:{
               FSAnzError( E_INV_EXPR );
               yyerrok;
               delete yypvt[-1].ptrSym;
            } break;
      case 298:{ delete [] yypvt[-0].ptrChar; } break;    }
    goto enstack;
}
